
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2015 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title BFC

@desc Bit Field Clear clears any number of adjacent bits at any position in a register, without affecting the other bits in the register.

@encoding (T1) {

	@word 1 1 1 1 0 0 1 1 0 1 1 0 1 1 1 1 0 imm3(3) Rd(4) imm2(2) 0 msb(5)

	@syntax <reg_D> <lsbit> <width>

	@conv {

		reg_D = Register(Rd)
		msbit = UInt(msb)
		lsbit = UInt(imm3:imm2)
		width = BitDiff(msbit, lsbit)

	}

}

@encoding (A1) {

	@word cond(4) 0 1 1 1 1 1 0 msb(5) Rd(4) lsb(5) 0 0 1 1 1 1 1

	@syntax <reg_D> <lsbit> <width>

	@conv {

		reg_D = Register(Rd)
		msbit = UInt(msb)
		lsbit = UInt(lsb)
		width = BitDiff(msbit, lsbit)

	}

	@rules {

		chk_call StoreCondition(cond)

	}

}

